{*******************************************************************************

                             TAvBannerAd Component

                  Copyright (c) 1999 Avrora LLC, Ecmel ERCAN

                              All Rights Reserved.

                        avrora@avrora.virtualave.net

                        http://avrora.virtualave.net



********************************************************************************
This is UNPUBLISHED PROPRIETARY SOURCE CODE of Avrora Software, LLC.;
the contents of this file may not be disclosed to third parties, copied or
duplicated in any form, in whole or in part, without the prior written
permission of Avrora Software, LLC.
*******************************************************************************}

{$DEFINE xDEMO}

unit avbannerex;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  ExtCtrls, ubannerfrm, gifctrl, rxgif;


type
  { TYPES ---------------------------------------------------------------------}

  TAvBannerExOption = (bexSilent, bexAutoDetect, bexUseCache, bexSeparateWindow,
    bexShowOnActivate, bexStayOnTop, bexAllowDrag);
  TAvBannerExOptions = set of TAvBannerExOption;

  TAvBanner = record
    ImagePath : String;
    Url : String;
  end;
  TAvBanners = array of TAvBanner;

  TAvBannerExStyle = (baBannerExchange, baCustom);

  TAvBannerEx = class;

  TAvOnProgressEvent = procedure(Sender: TObject; Readed: Integer) of object;
  TAvOnDoneFileEvent = procedure(Sender: TObject; FileName: String; FileSize: Integer) of object;

  { CLASSES -------------------------------------------------------------------}

  TAvHTTPGetThread = class(TThread)
  private
    { PRIMITIVES }
    BytesToRead         : DWord;
    BytesReaded         : DWord;
    FTToFile            : Boolean;
    FTBinaryData        : Boolean;
    FTUseCache          : Boolean;
    FTResult            : Boolean;
    FTFileSize          : Integer;
    FTAcceptTypes       : String;
    FTAgent             : String;
    FTURL               : String;
    FTFileName          : String;
    FTUserName          : String;
    FTPassword          : String;
    FTPostQuery         : String;
    FTReferer           : String;
    FTStringResult      : String;
    { PROCEDURAL }
    FTProgress          : TAvOnProgressEvent;
  protected
    constructor Create(aAcceptTypes, aAgent, aURL, aFileName, aUserName,
      aPassword, aPostQuery, aReferer: String; aBinaryData, aUseCache: Boolean;
      aProgress: TAvOnProgressEvent; aToFile: Boolean);
    procedure Execute; override;
    procedure UpdateProgress;
  end;

  {----------------------------------------------------------------------------}

  TAvHTTPGet = class
  private
    { POINTERS }
    FThread             : TAvHTTPGetThread;     { OWNED }
    FOwner              : TAvBannerEx;          { NIL }
    { PRIMITIVES }
    FResult             : Boolean;
    FBinaryData         : Boolean;
    FUseCache           : Boolean;
    FWaitThread         : Boolean;
    FAcceptTypes        : String;
    FAgent              : String;
    FURL                : String;
    FFileName           : String;
    FUserName           : String;
    FPassword           : String;
    FPostQuery          : String;
    FReferer            : String;
  protected
    procedure ThreadDone(Sender: TObject);
    procedure GetFile;
    procedure GetString;
    { START - ADDED BY ECMEL ERCAN }
    procedure GetCGIFile;
    { END - ADDED BY ECMEL ERCAN }
    procedure Abort;
  public
    constructor Create(AOwner: TAvBannerEx);
    destructor Destroy; override;
  published
    property AcceptTypes: String read FAcceptTypes write FAcceptTypes;
    property Agent: String read FAgent write FAgent;
    property BinaryData: Boolean read FBinaryData write FBinaryData;
    property URL: String read FURL write FURL;
    property UseCache: Boolean read FUseCache write FUseCache;
    property FileName: String read FFileName write FFileName;
    property UserName: String read FUserName write FUserName;
    property Password: String read FPassword write FPassword;
    property PostQuery: String read FPostQuery write FPostQuery;
    property Referer: String read FReferer write FReferer;
    property WaitThread: Boolean read FWaitThread write FWaitThread;
  end;

  { COMPONENTS ----------------------------------------------------------------}

  TAvBannerEx = class(TComponent)
  private
    { POINTERS }
    FTimer              : TTimer;               { OWNED }
    FBanners            : TAvBanners;           { OWNED }
    FBannerForm         : TAvBannerFrm;         { OWNED }
    FHTTPGet            : TAvHTTPGet;           { OWNED }
    FDefaultBanner      : TGifImage;            { OWNED }
    FWindowHandle       : hWnd;                 { OWNED }
    FRxGifAnimator      : TRxGifAnimator;       { NIL }
    { PRIMITIVES }
    FFirstTime          : Boolean;
    FActive             : Boolean;
    FEnabled            : Boolean;
    FStyle              : TAvBannerExStyle;
    FOptions            : TAvBannerExOptions;
    FOnline             : Boolean;
    FDispatchInterval   : Cardinal;
    FInterval           : Cardinal;
    FStartDelay         : Cardinal;
    FCurrBannerNo       : Integer;
    FBannerLeft         : Integer;
    FBannerTop          : Integer;
    FBannerSizeX        : Integer;
    FBannerSizeY        : Integer;
    FInfoFile           : string;
    FURL                : string;
    FDefaultURL         : String;
    FAgent              : String;
    FIP                 : String;
    { PROCEDURAL }
    FOnChanged          : TNotifyEvent;
    FOnError            : TNotifyEvent;
    FOnActiveChange     : TNotifyEvent;
    FOnLoad             : TAvOnDoneFileEvent;
    FProgress           : TAvOnProgressEvent;

    procedure SetDispatchInterval(Value: Cardinal);
    procedure SetNoneBool(Value: Boolean);
    procedure SetNoneStr(Value: String);
    procedure SetActive(const Value: Boolean);
    procedure SetBannerLeft(const Value: Integer);
    procedure SetBannerTop(const Value: Integer);
    procedure SetURL(const Value: string);
    procedure SetDefaultURL(const Value: String);
    procedure SetInterval(const Value: Cardinal);
    procedure SetStyle(const Value: TAvBannerExStyle);
    procedure SetAgent(const Value: String);
    procedure SetBannerSizeX(const Value: Integer);
    procedure SetBannerSizeY(const Value: Integer);
    procedure SetRxGifAnimator(const Value: TRxGifAnimator);
    procedure SetStartDelay(const Value: Cardinal);
    procedure SetDefaultBanner(const Value: TGifImage);
    procedure SetOptions(const Value: TAvBannerExOptions);
  protected
    procedure WndProc(var Msg: TMessage);
    procedure UpdateTimer;
    procedure OnTimer(Sender : TObject);
    function GetBanner : TAvBanner;
    procedure GetFileDone(Sender: TObject; FileName: String; FileSize: Integer);
    procedure GetPictureError(Sender: TObject);
    procedure GetStringDone(Sender: TObject; Result: String);
    function ParseInfoFile(FileName : String) : Boolean;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Loaded; override;
    procedure OnBannerClick(Sender : TObject);
    procedure Error;
    {$IFDEF DEMO}
    procedure RegisterDemo;
    {$ENDIF}
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published
    property Options : TAvBannerExOptions read FOptions write SetOptions
      default [bexAutoDetect, bexSeparateWindow, bexStayOnTop, bexAllowDrag];
    property DispatchInterval: Cardinal read FDispatchInterval write SetDispatchInterval;
    property Online: Boolean read FOnline write SetNoneBool;
    property IP: String read FIP write SetNoneStr;
    property DefaultBanner : TGifImage read FDefaultBanner write SetDefaultBanner;
    property BannerWidth : Integer read FBannerSizeX write SetBannerSizeX default 468;
    property BannerHeight : Integer read FBannerSizeY write SetBannerSizeY default 60;
    property Enabled : Boolean read FEnabled write FEnabled default True;
    property Style :  TAvBannerExStyle read FStyle write SetStyle default baBannerExchange;
    property Active : Boolean read FActive write SetActive default False;
    property ImageURL: string read FURL write SetURL;
    property IniFile : string read FInfoFile write FInfoFile;
    property Interval : Cardinal read FInterval write SetInterval default 10;
    property StartDelay : Cardinal read FStartDelay write SetStartDelay default 500;
    property BannerLeft : Integer read FBannerLeft write SetBannerLeft default -1;
    property BannerTop : Integer read FBannerTop write SetBannerTop default -1;
    property LinkURL : String read FDefaultURL write SetDefaultURL;
    property Agent: String read FAgent write SetAgent;
    property RxGifAnimator : TRxGifAnimator read FRxGifAnimator write SetRxGifAnimator default nil;
    { EVENTS }
    property OnActiveChanged : TNotifyEvent read FOnActiveChange write FOnActiveChange;
    property OnBannerError : TNotifyEvent read FOnError write FOnError;
    property OnBannerLoad : TAvOnDoneFileEvent read FOnLoad write FOnLoad;
    property OnBannerProgress: TAvOnProgressEvent read FProgress write FProgress;
    property OnOnlineChanged: TNotifyEvent read FOnChanged write FOnChanged;
  end;

procedure Register;

  {----------------------------------------------------------------------------}

implementation

uses ShellApi, WinSock, WinInet;

procedure Register;
begin
  RegisterComponents('Avrora', [TAvBannerEx]);
end;

{ TAvBannerAdOptions }

{$IFDEF DEMO}
procedure TAvBannerEx.RegisterDemo;
begin
  if (csDesigning in ComponentState) and not (csLoading in ComponentState) then
    MessageDlg('This program is not registered.  Please register your software to use this feature.', mtWarning, [mbOk], 0);
end;
{$ENDIF}

function LocalIP: String;
type
  TaPInAddr = Array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: Array[0..63] of Char;
  I: Integer;
  GInitData: TWSAData;
begin
  WSAStartup($101, GInitData);
  Result := '';
  GetHostName(Buffer, SizeOf(Buffer));
  phe := GetHostByName(buffer);
  if phe = nil then Exit;
  pPtr := PaPInAddr(phe^.h_addr_list);
  I := 0;
  while pPtr^[I] <> nil do
   begin
    Result := inet_ntoa(pptr^[I]^);
    Inc(I);
   end;
  WSACleanup;
end;

constructor TAvBannerEx.Create(AOwner : TComponent);
begin
  inherited;
  FOptions := [bexAutoDetect, bexSeparateWindow, bexStayOnTop, bexAllowDrag];
  FDispatchInterval := 1000;
  FWindowHandle := AllocateHWnd(WndProc);
  UpdateTimer;
  FDefaultBanner := TGifImage.Create;
  FBannerSizeX := 468;
  FBannerSizeY := 60;
  FEnabled := True;
  FURL := 'http://www.linkbuddies.com/image.go?id=130841';
  FDefaultURL := 'http://www.linkbuddies.com/click.go?id=130841';
  FAgent := 'AVRORA BANNER COMPONENT';
  FHTTPGet := TAvHTTPGet.Create(self);
  FHTTPGet.FileName := ExtractFilePath(ParamStr(0)) + 'banner.tmp';
  FHTTPGet.Agent := FAgent;
  FHTTPGet.URL := FURL;
  FBannerLeft := -1;
  FBannerTop := -1;
  FBannerForm := TAvBannerFrm.Create(nil);
  FBannerForm.FBannerAd := Self;
  FBannerForm.URL := FDefaultURL;
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.OnTimer := OnTimer;
  FInterval := 10;
  FStartDelay := 500;
  FTimer.Interval := FStartDelay;
  FCurrBannerNo := 0;
  SetLength(FBanners, 0);
end;

destructor TAvBannerEx.Destroy;
begin
  FDefaultBanner.Free;
  FTimer.Free;
  FBanners := nil;
  FBannerForm.Release;
  FHTTPGet.Free;
  FOptions := FOptions - [bexAutoDetect];
  UpdateTimer;
  DeallocateHWnd(FWindowHandle);
  inherited;
end;

procedure TAvBannerEx.OnTimer(Sender: TObject);
var
  ABanner : TAvBanner;
begin
  if FStyle = baCustom then
  begin
    if FFirstTime then
    begin
      FTimer.Interval := FInterval * 1000;
      FHTTPGet.URL := FURL + FInfoFile;
      FHTTPGet.BinaryData := False;
      FHTTPGet.GetFile;
    end
    else
    begin
      FTimer.Enabled := False;
      ABanner := GetBanner;
      FHTTPGet.URL := FURL + ABanner.ImagePath;      
      FHTTPGet.BinaryData := True;
      FHTTPGet.GetFile;
    end;
  end
  else
    begin
     if FFirstTime then
     begin
       FTimer.Interval := FInterval * 1000;
       FFirstTime := False;
     end;
      FTimer.Enabled := False;
      FHTTPGet.GetCGIFile;
    end;
end;

procedure TAvBannerEx.SetActive(const Value: Boolean);
begin
  if not FEnabled then Exit;
  if not (csDesigning in ComponentState) then
  begin
  if FActive <> Value then
    if Value then
    begin
      FActive := Value;
      FFirstTime := True;
      FTimer.Interval := FStartDelay;
      FTimer.Enabled := True;
      if (bexShowOnActivate in FOptions) and (bexSeparateWindow in FOptions) then
        FBannerForm.Show;
      if Assigned(FOnActiveChange) then
        FOnActiveChange(Self);
    end
    else
    begin
      FActive := Value;
      if FBannerForm.Visible then
        FBannerForm.Hide;
      FTimer.Enabled := False;
      FHTTPGet.Abort;
      if Assigned(FOnActiveChange) then
        FOnActiveChange(Self);

    end
  end
  else
    FActive := Value;
end;

function TAvBannerEx.ParseInfoFile(FileName : String): Boolean;
var
  IFile : Text;
  Line : String;

  EqPos : Integer;

  TkValue, TkData : String;
begin
  Result := True;
  if FileExists(FileName) then
  begin
    AssignFile(IFile, FileName);
    Reset(IFile);
    try
    try
    { FIND INFO SECTION }
    while not Eof(IFile) do
    begin
      ReadLn(IFile, Line);
      if UpperCase(Copy(Line, 0, 6)) = '[INFO]' then
      begin
        ReadLn(IFile, Line);
        Break;
      end;
    end;

    if Eof(IFile) then
    begin
      Result := False;
      Exit;
    end;

    { FIND TOKENS }
    while not (Copy(Line, 0, 1) = '[') do
    begin
      repeat
        ReadLn(IFile, Line);
      until (Copy(Line, 0, 1) <> ';') or Eof(IFile);

      EqPos := 0;
      repeat
        Inc(EqPos);
      until (Copy(Line, EqPos, 1) = '=') or (EqPos > (Length(Line) - 1));

      if EqPos > (Length(Line) - 1) then
        Break;

      TkValue := Copy(Line, 0, EqPos - 1);
      TkValue := UpperCase(TkValue);
      TkData  := Copy(Line, EqPos + 1, Length(Line) - EqPos);

      if TkValue = 'ENABLED' then
        Enabled := UpperCase(TkData) = 'TRUE'
      else
      if TkValue = 'AGENT' then
        Agent := TkData
      else
      if TkValue = 'BANNERLEFT' then
        BannerLeft := StrToInt(TkData)
      else
      if TkValue = 'BANNERTOP' then
        BannerTop := StrToInt(TkData)
      else
      if TkValue = 'IMAGEURL' then
        ImageURL := TkData
      else
      if TkValue = 'LINKURL' then
        LinkURL := TkData
      else
      if TkValue = 'INTERVAL' then
        Interval := StrToInt(TkData)
      else
      if TkValue = 'STARTDELAY' then
        StartDelay := StrToInt(TkData)
      else
      if TkValue = 'USECACHE' then
      begin
        if UpperCase(TkData) = 'TRUE' then
          FOptions := FOptions + [bexUseCache]
        else
          FOptions := FOptions - [bexUseCache];
      end
      else
      if TkValue = 'STAYONTOP' then
      begin
        if UpperCase(TkData) = 'TRUE' then
          FOptions := FOptions + [bexStayOnTop]
        else
          FOptions := FOptions - [bexStayOnTop];
      end
      else
      if TkValue = 'BANNERWIDTH' then
        BannerWidth := StrToInt(TkData)
      else
      if TkValue = 'BANNERHEIGHT' then
        BannerHeight := StrToInt(TkData)
      else
      if TkValue = 'STYLE' then
        if UpperCase(TkData) = 'BABANNEREXCHANGE' then
          Style := baBannerExchange
        else
          Style := baCustom;
    end;

    { FIND BANNERS SECTION }
    while not Eof(IFile) do
    begin
      ReadLn(IFile, Line);
      if UpperCase(Copy(Line, 0, 9)) = '[BANNERS]' then
        Break;
    end;

    { GET BANNERS }
    if not Eof(IFIle) then
    begin
      SetLength(FBanners, 0);
      FCurrBannerNo := 0;
      while not Eof(IFile) do
      begin
        SetLength(FBanners, Length(FBanners) + 1);
        ReadLn(IFile, Line);
        FBanners[Length(FBanners) - 1].ImagePath := Line;
        ReadLn(IFile, Line);
        FBanners[Length(FBanners) - 1].Url := Line;
      end;
    end;
    finally
    CloseFile(IFile);
    end;
    except
      if not (bexSilent in FOptions) then
        MessageDlg('Error parsing ' + FInfoFile + '.', mtError, [mbOk], 0);
      Active := False;
      Error;
    end
  end
  else
  begin
    if not (bexSilent in FOptions) then
      MessageDlg(FInfoFile + ' file not found.', mtError, [mbOk], 0);
    Result := False;
    Error;
  end;
end;

function TAvBannerEx.GetBanner: TAvBanner;
begin
  Result := FBanners[FCurrBannerNo];
  Inc(FCurrBannerNo);
  if FCurrBannerNo > Length(FBanners) - 1 then
    FCurrBannerNo := 0;
end;


procedure TAvBannerEx.SetBannerLeft(const Value: Integer);
begin
  FBannerLeft := Value;
  if Value >= 0 then
    FBannerForm.Left := Value
  else
    FBannerForm.Left := (Screen.Width - FBannerForm.Width) div 2;
end;

procedure TAvBannerEx.SetBannerTop(const Value: Integer);
begin
  FBannerTop := Value;
  if Value >= 0 then
    FBannerForm.Top := Value
  else
    FBannerForm.Top := 0;
end;


procedure TAvBannerEx.SetURL(const Value: string);
begin
 {$IFDEF DEMO}
 RegisterDemo;
 {$ELSE}
  FURL := Value;
  FHTTPGet.URL := Value;
 {$ENDIF}
end;


procedure TAvBannerEx.GetFileDone(Sender: TObject; FileName: String;
  FileSize: Integer);
var
  ABanner : TRxGifAnimator;
begin
  if FStyle = baCustom then
  begin
    if FFirstTime then
    begin
      FFirstTime := False;
      if not ParseInfoFile(FileName) then
        Active := False;
    end
    else
    begin
       if (not (bexSeparateWindow in FOptions)) and (FRxGifAnimator <> nil) then
         ABanner := FRxGifAnimator
       else
         ABanner := FBannerForm.Banner;

       ABanner.Animate := False;
       try
         try
           ABanner.Image.LoadFromFile(FileName);
         finally
           ABanner.Animate := True;
           if FCurrBannerNo > 0 then
             FBannerForm.URL := FBanners[FCurrBannerNo - 1].Url
           else
             FBannerForm.URL := FBanners[FCurrBannerNo].Url;
           if bexSeparateWindow in FOptions then
             if not FBannerForm.Visible then
               FBannerForm.Show;
           FTimer.Enabled := True;
           if Assigned(FOnLoad) then
             FOnLoad(Self, FileName, FileSize);
         end;
       except
         Active := False;
         if not (bexSilent in FOptions) then
           MessageDlg('Download error.', mtError, [mbOk], 0);
         Error;
       end;
    end;
  end
  else
    begin
       if (not (bexSeparateWindow in FOptions)) and (FRxGifAnimator <> nil) then
         ABanner := FRxGifAnimator
       else
         ABanner := FBannerForm.Banner;

       ABanner.Animate := False;

       ABanner.Animate := False;
       try
         try
           ABanner.Image.LoadFromFile(FileName);
         finally
           ABanner.Animate := True;
           FBannerForm.URL := FDefaultURL;
           if bexSeparateWindow in FOptions then
             if not FBannerForm.Visible then
               FBannerForm.Show;
           FTimer.Enabled := True;
           if Assigned(FOnLoad) then
             FOnLoad(Self, FileName, FileSize);
         end;
       except
         Active := False;
         if not (bexSilent in FOptions) then
           MessageDlg('Download error.', mtError, [mbOk], 0);
         Error;
       end;
    end;
end;


procedure TAvBannerEx.GetPictureError(Sender: TObject);
begin
  Active := False;
  if not (bexSilent in FOptions) then
    MessageDlg('Download error.', mtError, [mbOk], 0);
  Error;
end;




procedure TAvBannerEx.SetDefaultURL(const Value: String);
begin
  {$IFDEF DEMO}
  RegisterDemo;
  {$ELSE}
  FDefaultURL := Value;
  FBannerForm.URL := Value;
  {$ENDIF}
end;


procedure TAvBannerEx.SetInterval(const Value: Cardinal);
begin
  if (Value > 0) and (Value < 30) then
    FInterval := Value;
end;


procedure TAvBannerEx.SetStyle(const Value: TAvBannerExStyle);
begin
  {$IFDEF DEMO}
  RegisterDemo;
  {$ELSE}
  FStyle := Value;
  {$ENDIF}
end;


procedure TAvBannerEx.SetAgent(const Value: String);
begin
  FAgent := Value;
  FHTTPGet.Agent := Value;
end;


procedure TAvBannerEx.SetBannerSizeX(const Value: Integer);
begin
  FBannerSizeX := Value;
  if FBannerForm.Dragger.Visible then
    FBannerForm.ClientWidth := FBannerSizeX + FBannerForm.Dragger.Width
  else
    FBannerForm.ClientWidth := FBannerSizeX;

  FBannerForm.Banner.Width := FBannerSizeX;
end;


procedure TAvBannerEx.SetBannerSizeY(const Value: Integer);
begin
  FBannerSizeY := Value;
  FBannerForm.ClientHeight := FBannerSizeY;
  FBannerForm.Banner.Height := FBannerSizeY;
end;


procedure TAvBannerEx.SetRxGifAnimator(const Value: TRxGifAnimator);
begin
  FRxGifAnimator := Value;
  if Value <> nil then
  begin
    Value.Animate := True;
    Value.Transparent := False;
    Value.Cursor := crHandPoint;
    Value.Width := BannerWidth;
    Value.Height := BannerHeight;
    if csDesigning in ComponentState then
    begin
      FOptions := FOptions - [bexSeparateWindow];

      if not FDefaultBanner.Empty then
      begin
        Value.Image.Assign(FDefaultBanner);
        FDefaultBanner.Assign(nil);
      end;
    end;
  end;
end;



procedure TAvBannerEx.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if csDesigning in ComponentState then
    if Operation = opRemove then
      if AComponent = FRxGifAnimator then
        FRxGifAnimator := nil
end;


procedure TAvBannerEx.Loaded;
begin
  inherited;
  if (not (bexSeparateWindow in FOptions)) and (FRxGifAnimator <> nil) then
    FRxGifAnimator.OnClick := OnBannerClick;
end;


procedure TAvBannerEx.OnBannerClick(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar(FBannerForm.URL), '', '', SW_SHOWNORMAL);
end;




procedure TAvBannerEx.SetStartDelay(const Value: Cardinal);
begin
  if Value >= 100 then
    FStartDelay := Value;
end;


procedure TAvBannerEx.SetDefaultBanner(const Value: TGifImage);
begin
  if (FRxGifAnimator <> nil) and (Value <> nil) then
    FRxGifAnimator.Image.Assign(Value)
  else
    FDefaultBanner.Assign(Value);
end;


procedure TAvBannerEx.Error;
begin
  if Assigned(FOnError) then
    FOnError(Self);
end;

{ONLINE DEDECTION}

procedure TAvBannerEx.SetDispatchInterval(Value: Cardinal);
begin
  if Value <> FDispatchInterval then
   begin
    FDispatchInterval := Value;
    UpdateTimer;
   end;
end;


procedure TAvBannerEx.SetNoneBool(Value: Boolean);
begin

end;


procedure TAvBannerEx.SetNoneStr(Value: String);
begin

end;


procedure TAvBannerEx.UpdateTimer;
begin
  if not(csDesigning in ComponentState) then
  begin
    KillTimer(FWindowHandle, 1);
    if (FDispatchInterval <> 0) and (bexAutoDetect in FOptions) then
     SetTimer(FWindowHandle, 1, FDispatchInterval, nil);
  end;
end;


procedure TAvBannerEx.WndProc(var Msg: TMessage);
var
  OldState: Boolean;
begin
  with Msg do
   if Msg = wm_Timer then
    try
     FIP := LocalIP;
     OldState := FOnline;
     FOnline := (FIP <> '') and (FIP <> '127.0.0.1');
     if (not OldState and FOnline) or
        (OldState and not FOnline) then
        begin
          if Assigned(FOnChanged) then FOnChanged(Self);
          Active := FOnline;
        end;
    except
     Application.HandleException(Self);
    end
   else
    Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
end;


{*************************************************************}
{            HTTPGet component for Delphi 32                  }
{ Version:   1.94                                             }
{ E-Mail:    info@utilmind.com                                }
{ WWW:       http://www.utilmind.com                          }
{ Created:   October  19, 1999                                }
{ Modified:  June 6, 2000                                     }
{ Legal:     Copyright (c) 1999-2000, UtilMind Solutions      }
{*************************************************************}
{ PROPERTIES:                                                 }
{   Agent: String - User Agent                                }
{                                                             }
{*  BinaryData: Boolean - This setting specifies which type   }
{*                        of data will taken from the web.    }
{*                        If you set this property TRUE then  }
{*                        component will determinee the size  }
{*                        of files *before* getting them from }
{*                        the web.                            }
{*                        If this property is FALSE then as we}
{*                        do not knows the file size the      }
{*                        OnProgress event will doesn't work. }
{*                        Also please remember that is you set}
{*                        this property as TRUE you will not  }
{*                        capable to get from the web ASCII   }
{*                        data and ofter got OnError event.   }
{                                                             }
{   FileName: String - Path to local file to store the data   }
{                      taken from the web                     }
{   Password, UserName - set this properties if you trying to }
{                        get data from password protected     }
{                        directories.                         }
{   Referer: String - Additional data about referer document  }
{   URL: String - The url to file or document                 }
{   UseCache: Boolean - Get file from the Internet Explorer's }
{                       cache if requested file is cached.    }
{*************************************************************}
{ METHODS:                                                    }
{   GetFile - Get the file from the web specified in the URL  }
{             property and store it to the file specified in  }
{             the FileName property                           }
{   GetString - Get the data from web and return it as usual  }
{               String. You can receive this string hooking   }
{               the OnDoneString event.                       }
{   Abort - Stop the current session                          }
{*************************************************************}
{ EVENTS:                                                     }
{   OnDoneFile - Occurs when the file is downloaded           }
{   OnDoneString - Occurs when the string is received         }
{   OnError - Occurs when error happend                       }
{   OnProgress - Occurs at the receiving of the BINARY DATA   }
{*************************************************************}
{ Please see demo program for more information.               }
{*************************************************************}
{                     IMPORTANT NOTE:                         }
{ This software is provided 'as-is', without any express or   }
{ implied warranty. In no event will the author be held       }
{ liable for any damages arising from the use of this         }
{ software.                                                   }
{ Permission is granted to anyone to use this software for    }
{ any purpose, including commercial applications, and to      }
{ alter it and redistribute it freely, subject to the         }
{ following restrictions:                                     }
{ 1. The origin of this software must not be misrepresented,  }
{    you must not claim that you wrote the original software. }
{    If you use this software in a product, an acknowledgment }
{    in the product documentation would be appreciated but is }
{    not required.                                            }
{ 2. Altered source versions must be plainly marked as such,  }
{    and must not be misrepresented as being the original     }
{    software.                                                }
{ 3. This notice may not be removed or altered from any       }
{    source distribution.                                     }
{*************************************************************}

 { TAvHTTPGetThread }

constructor TAvHTTPGetThread.Create(aAcceptTypes, aAgent, aURL, aFileName, aUserName, aPassword, aPostQuery, aReferer: String;
                                  aBinaryData, aUseCache: Boolean; aProgress: TAvOnProgressEvent; aToFile: Boolean);
begin
  FreeOnTerminate := True;
  inherited Create(True);
  FTAcceptTypes := aAcceptTypes;
  FTAgent := aAgent;
  FTURL := aURL;
  FTFileName := aFileName;
  FTUserName := aUserName;
  FTPassword := aPassword;
  FTPostQuery := aPostQuery;
  FTReferer := aReferer;
  FTProgress := aProgress;
  FTBinaryData := aBinaryData;
  FTUseCache := aUseCache;
  FTToFile := aToFile;
  Resume;
end;

procedure TAvHTTPGetThread.UpdateProgress;
begin
  FTProgress(Self, BytesReaded);
end;

procedure TAvHTTPGetThread.Execute;
var
  hSession, hConnect, hRequest: hInternet;
  HostName, FileName: String;
  f: File;
  Buf: Pointer;
  dwBufLen, dwIndex: DWord;
  Data: Array[0..$400] of Char;
  TempStr: String;
  RequestMethod: PChar;
  InternetFlag: DWord;
  AcceptType: LPStr;

  procedure ParseURL(URL: String; var HostName, FileName: String);

    procedure ReplaceChar(c1, c2: Char; var St: String);
    var
      p: Integer;
    begin
      while True do
       begin
        p := Pos(c1, St);
        if p = 0 then Break
        else St[p] := c2;
       end;
    end;

  var
    i: Integer;
  begin
    if Pos('http://', LowerCase(URL)) <> 0 then
      System.Delete(URL, 1, 7);

    i := Pos('/', URL);
    HostName := Copy(URL, 1, i);
    FileName := Copy(URL, i, Length(URL) - i + 1);

    if (Length(HostName) > 0) and (HostName[Length(HostName)] = '/') then
      SetLength(HostName, Length(HostName) - 1);
  end;

 procedure CloseHandles;
 begin
   InternetCloseHandle(hRequest);
   InternetCloseHandle(hConnect);
   InternetCloseHandle(hSession);
 end;

begin
  try
    ParseURL(FTURL, HostName, FileName);

    if Terminated then
     begin
      FTResult := False;
      Exit;
     end;

    if FTAgent <> '' then
     hSession := InternetOpen(PChar(FTAgent),
       INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0)
    else
     hSession := InternetOpen(nil,
       INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);

    hConnect := InternetConnect(hSession, PChar(HostName),
      INTERNET_DEFAULT_HTTP_PORT, PChar(FTUserName), PChar(FTPassword), INTERNET_SERVICE_HTTP, 0, 0);

    if FTPostQuery = '' then RequestMethod := 'GET'
    else RequestMethod := 'POST';

    if FTUseCache then InternetFlag := 0
    else InternetFlag := INTERNET_FLAG_RELOAD;

    AcceptType := PChar('Accept: ' + FTAcceptTypes);
    hRequest := HttpOpenRequest(hConnect, RequestMethod, PChar(FileName), 'HTTP/1.0',
                PChar(FTReferer), @AcceptType, InternetFlag, 0);

    if FTPostQuery = '' then
     HttpSendRequest(hRequest, nil, 0, nil, 0)
    else
     HttpSendRequest(hRequest, 'Content-Type: application/x-www-form-urlencoded', 47,
                     PChar(FTPostQuery), Length(FTPostQuery));

    if Terminated then
     begin
      CloseHandles;
      FTResult := False;
      Exit;
     end;

    dwIndex  := 0;
    dwBufLen := 1024;
    GetMem(Buf, dwBufLen);

    FTResult := HttpQueryInfo(hRequest, HTTP_QUERY_CONTENT_LENGTH,
                              Buf, dwBufLen, dwIndex);

    if Terminated then
     begin
      FreeMem(Buf);
      CloseHandles;
      FTResult := False;
      Exit;
     end;

    if FTResult or not FTBinaryData then
     begin
      if FTResult then
        FTFileSize := StrToInt(StrPas(Buf));

      BytesReaded := 0;

      if FTToFile then
       begin
        AssignFile(f, FTFileName);
        Rewrite(f, 1);
       end
      else FTStringResult := '';

      while True do
       begin
        if Terminated then
         begin
          if FTToFile then CloseFile(f);
          FreeMem(Buf);
          CloseHandles;

          FTResult := False;
          Exit;
         end;

        if not InternetReadFile(hRequest, @Data, SizeOf(Data), BytesToRead) then Break
        else
         if BytesToRead = 0 then Break
         else
          begin
           if FTToFile then
            BlockWrite(f, Data, BytesToRead)
           else
            begin
             TempStr := Data;
             SetLength(TempStr, BytesToRead);
             FTStringResult := FTStringResult + TempStr;
            end;

           inc(BytesReaded, BytesToRead);
           if Assigned(FTProgress) then
            Synchronize(UpdateProgress);
          end;
       end;

      if FTToFile then
       { START - ADDED BY ECMEL ERCAN }
        FTResult := BytesReaded <> 0   ///FTFileSize = Integer(BytesReaded)
       { END - ADDED BY ECMEL ERCAN }
      else
       begin
        SetLength(FTStringResult, BytesReaded);
        FTResult := BytesReaded <> 0;
       end;

      if FTToFile then CloseFile(f);       
     end;

    FreeMem(Buf);

    CloseHandles;
  except
  end;
end;

 { TAvHTTPGet }

constructor TAvHTTPGet.Create(AOwner: TAvBannerEx);
begin
  inherited Create;
  FOwner := AOwner;
  FAcceptTypes := '*/*';
  FAgent := 'UtilMind HTTPGet';
end;

destructor TAvHTTPGet.Destroy;
begin
  Abort;
  FOwner := nil;
  inherited Destroy;
end;

procedure TAvHTTPGet.GetFile;
var
  Msg: TMsg;
begin
  if not Assigned(FThread) then
   begin
    FThread := TAvHTTPGetThread.Create(FAcceptTypes, FAgent, FURL, FFileName, FUserName, FPassword, FPostQuery, FReferer,
                                     FBinaryData, FUseCache, FOwner.FProgress, True);
    FThread.OnTerminate := ThreadDone;
    if FWaitThread then
    while Assigned(FThread) do
     while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
   end
end;

procedure TAvHTTPGet.GetString;
var
  Msg: TMsg;
begin
  if not Assigned(FThread) then
   begin
    FThread := TAvHTTPGetThread.Create(FAcceptTypes, FAgent, FURL, FFileName, FUserName, FPassword, FPostQuery, FReferer,
                                     FBinaryData, FUseCache, FOwner.FProgress, False);
    FThread.OnTerminate := ThreadDone;
    if FWaitThread then
     while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
   end
end;

procedure TAvHTTPGet.Abort;
begin
  if Assigned(FThread) then
   begin
    FThread.Terminate;
    FThread.FTResult := False;
   end;
end;

procedure TAvHTTPGet.ThreadDone(Sender: TObject);
begin
  FResult := FThread.FTResult;
  if FResult then
   if FThread.FTToFile then
    FOwner.GetFileDone(Self, FThread.FTFileName, FThread.FTFileSize)
//    if Assigned(FDoneFile) then FDoneFile(Self, FThread.FTFileName, FThread.FTFileSize) else
   else
    FOwner.GetStringDone(Self, FThread.FTStringResult)
//    if Assigned(FDoneString) then FDoneString(Self, FThread.FTStringResult) else
  else
   FOwner.GetPictureError(Self);
//   if Assigned(FError) then FError(Self);
  FThread := nil;  
end;


{ START - ADDED BY ECMEL ERCAN }
procedure TAvHTTPGet.GetCGIFile;
var
  Msg: TMsg;
begin
  if not Assigned(FThread) then
   begin
    FThread := TAvHTTPGetThread.Create(FAcceptTypes, FAgent, FURL, FFileName, FUserName, FPassword, FPostQuery, FReferer,
                                     FBinaryData, FUseCache, FOwner.FProgress, True);
    FThread.OnTerminate := ThreadDone;
    if FWaitThread then
     while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
   end
end;
{ END - ADDED BY ECMEL ERCAN }


procedure TAvBannerEx.SetOptions(const Value: TAvBannerExOptions);
begin
  if FOptions <> Value then
  begin
    if ((bexAutoDetect in FOptions) and (not (bexAutoDetect in Value))) or
       ((bexAutoDetect in Value) and (not (bexAutoDetect in FOptions))) then
      UpdateTimer;

    if bexStayOnTop in Value then
      FBannerForm.FormStyle := fsStayOnTop
    else
      FBannerForm.FormStyle := fsNormal;

    FHTTPGet.UseCache := bexUseCache in Value;

    if FActive then
      if bexSeparateWindow in Value then
          FBannerForm.Show
        else
          FBannerForm.Hide;

    if bexAllowDrag in Value then
    begin
      FBannerForm.Banner.Left := FBannerForm.Dragger.Width;
      FBannerForm.ClientWidth := FBannerForm.Banner.Width + FBannerForm.Dragger.Width;
      FBannerForm.Dragger.Visible := True;
    end
    else
    begin
      FBannerForm.Banner.Left := 0;
      FBannerForm.ClientWidth := FBannerForm.Banner.Width;
      FBannerForm.Dragger.Visible := False;
    end;

    FOptions := Value;

    if csDesigning in ComponentState then
      if FRxGifAnimator = nil then
        FOptions := FOptions + [bexSeparateWindow];
  end;
end;

procedure TAvBannerEx.GetStringDone(Sender: TObject; Result: String);
begin

end;

end.
