{*******************************************************************************

                             TAvBannerAd Component

                 Copyright 2000, Avrora Software & Ecmel ERCAN

                              All Rights Reserved.

********************************************************************************
This is UNPUBLISHED PROPRIETARY SOURCE CODE of Avrora Software, LLC.;
the contents of this file may not be disclosed to third parties, copied or
duplicated in any form, in whole or in part, without the prior written
permission of Avrora Software, LLC.
*******************************************************************************}

unit ubannerfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Animate, GIFCtrl, ExtCtrls;

type
  TAvBannerFrm = class(TForm)
    Banner: TRxGIFAnimator;
    Dragger: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BannerClick(Sender: TObject);
    procedure DraggerPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    FBannerAd : TComponent;
    URL : String;
  end;

var
  AvBannerFrm: TAvBannerFrm;

implementation

{$R *.DFM}

uses avbannerex, shellapi;

procedure TAvBannerFrm.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width - Width) div 2;
  Top := 0;
end;

procedure TAvBannerFrm.WndProc(var Message: TMessage);
var
  CPoint, point : TPoint;
  PR : PRect;
begin
  inherited;
  case Message.Msg of
  WM_NCHITTEST :
    begin
      point.x:=TWMNCHitTest(Message).Xpos;
      point.y:=TWMNCHitTest(Message).Ypos;
      CPoint:= Self.ScreenToClient(point);
      if Dragger.Visible then
        if (Message.Result = htClient) and (CPoint.x <= 10) then
          Message.Result:=htCaption;
    end;
  WM_MOVING :
    begin
      PR := Pointer(Message.LParam);

      if PR^.Left < 0 then
       begin
        PR^.left := 0;
        PR^.Right := Width;
       end;

      if PR^.Top < 0 then
        begin
          PR^.top := 0;
          PR^.Bottom := Height;
        end;

      if PR^.Bottom > screen.height then
        begin
         PR^.Bottom := screen.height;
         PR^.top := screen.height - height;
        end;

      if PR^.Right > Screen.Width then
        begin
          PR^.Right := screen.width;
          PR^.Left := screen.width - width;
        end;

     TAvBannerEx(FBannerAd).BannerLeft := PR^.Left;
     TAvBannerEx(FBannerAd).BannerTop := PR^.Top;
    end;
  end;
end;

procedure TAvBannerFrm.FormDestroy(Sender: TObject);
begin
  FBannerAd := nil;
end;

procedure TAvBannerFrm.BannerClick(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar(URL), '', '', SW_SHOWNORMAL);
end;

procedure TAvBannerFrm.DraggerPaint(Sender: TObject);
var
  PaintRect : TRect;
begin
  PaintRect.Left := 0;
  PaintRect.Top := 0;
  PaintRect.Right := Dragger.Width;
  PaintRect.Bottom := Dragger.Height;
  Dragger.Canvas.Brush.Color := clBtnFace;
  Dragger.Canvas.Pen.Color := clBtnFace;
  Dragger.Canvas.FillRect(PaintRect);
  DrawEdge(Dragger.Canvas.Handle, PaintRect, EDGE_RAISED, BF_RECT);
end;

procedure TAvBannerFrm.FormShow(Sender: TObject);
begin

  if not (FBannerAd as TAvBannerEx).DefaultBanner.Empty then
    Banner.Image.Assign((FBannerAd as TAvBannerEx).DefaultBanner)
  else
  if (FBannerAd as TAvBannerEx).RxGifAnimator <> nil then
    Banner.Image.Assign((FBannerAd as TAvBannerEx).RxGifAnimator.Image);
    
end;

end.
